## Male female mapps independently
## GenAllmaps
setwd('~/Desktop/Old_Desktop/Map Paper/DATA/')
setwd('~/Dropbox/Map Paper/DATA/')
plotdir <- '~/Desktop/Old_Desktop/Map Paper/raw_figures'
x <- c('stringr','reshape2','gdata')
lapply(x, require, character.only = TRUE)

#### Process Male and Female .gff files ####

male.gff <- read.delim('Male.gff',header=F, comment.char="#")
female.gff <- read.delim('Female.gff',header=F, comment.char="#")

male.gff <- male.gff[which(male.gff$V3=='gene'),]
male.gff <- data.frame(male.gff,NCBI_scaff=gsub('.*NOTES=','',male.gff$V9), stringsAsFactors = FALSE)
male.gff$V1 <- gsub('chr','',male.gff$V1)
male.gff$V9 <- gsub('.*Dbxref=GeneID:','', male.gff$V9)
male.gff$V9 <- gsub(';Name=.*','', male.gff$V9)
male.gff <- male.gff[!duplicated(male.gff$V9),]
row.names(male.gff) <- male.gff$V9
female.gff <- female.gff[which(female.gff$V3=='gene'),]
female.gff <- data.frame(female.gff,NCBI_scaff=gsub('.*NOTES=','',female.gff$V9), stringsAsFactors = FALSE)
female.gff$V1 <- gsub('chr','',female.gff$V1)
female.gff$V9 <- gsub('.*Dbxref=GeneID:','', female.gff$V9)
female.gff$V9 <- gsub(';Name=.*','', female.gff$V9)
female.gff <- female.gff[!duplicated(female.gff$V9),]
row.names(female.gff) <- female.gff$V9
#######################################
#### Gen karyotpe files and highlights ####
## Max position of each chromosome for both male and female
# mf.kary <- data.frame(frntmatter = 'chr -', chr = paste('FH',unique(as.numeric(c(male.gff$V1, female.gff$V1))), sep = ''),chr.num = unique(as.numeric(c(male.gff$V1, female.gff$V1))),srt = 0,end=NA,col = paste('chr',unique(as.numeric(c(male.gff$V1, female.gff$V1))), sep = '')     )
mf.kary <- data.frame(frntmatter = 'chr -',
                      chr = paste('FH',unique(as.numeric(c(male.gff$V1, female.gff$V1))), sep = ''),
                      chr.num = unique(as.numeric(c(male.gff$V1, female.gff$V1))),
                      srt = 0,
                      end=NA,
                      col = 'white')
mf.kary <- mf.kary[!is.na(mf.kary$chr.num),]
for (i in 1:length(unique(mf.kary$chr))){
  mf.kary$end[i] <- max(as.numeric(c(male.gff$V5[which(male.gff$V1==mf.kary$chr.num[i])],female.gff$V5[which(female.gff$V1==mf.kary$chr.num[i])])))
}
mf.kary <- mf.kary[order(as.numeric(mf.kary$chr.num)),]

write.table(mf.kary,
            file = 'mf.kary',
            quote = FALSE, col.names = FALSE, row.names = FALSE)

write.table(data.frame(mf.kary$chr,mf.kary$srt,mf.kary$end),
            file = 'mf.kary.highlights',
            quote = FALSE, col.names = FALSE, row.names = FALSE)

male.highlights <- data.frame(do.call('rbind',strsplit(unique(paste(male.gff$V1,male.gff$NCBI_scaff, sep = ' ')), ' ',fixed = TRUE)),
                              strt=NA,
                              stp=NA,
                              fill_color=NA)

female.highlights <- data.frame(do.call('rbind',strsplit(unique(paste(female.gff$V1,female.gff$NCBI_scaff, sep = ' ')), ' ',fixed = TRUE)),
                                strt=NA,
                                stp=NA,
                                fill_color=NA)

for (i in 1:length(male.highlights$X1)){
  male.highlights$strt[i] <- min(as.numeric(male.gff$V4[which(male.gff$NCBI_scaff==male.highlights$X2[i])]))
  male.highlights$stp[i] <- max(as.numeric(male.gff$V5[which(male.gff$NCBI_scaff==male.highlights$X2[i])]))
  male.highlights$fill_color[i] <- NA
}

for (i in 1:length(female.highlights$X1)){
  female.highlights$strt[i] <- min(as.numeric(female.gff$V4[which(female.gff$NCBI_scaff==female.highlights$X2[i])]))
  female.highlights$stp[i] <- max(as.numeric(female.gff$V5[which(female.gff$NCBI_scaff==female.highlights$X2[i])]))
  female.highlights$fill_color <- NA
}

########################################################
###### Color consistency across all plots #####################################
## https://www.nceas.ucsb.edu/~frazier/RSpatialGuides/colorPaletteCheatsheet.pdf
cnvrt.scaf <- data.frame(out=gsub('Scaffold','',AW.conv$corrected),row.names = AW.conv$RefSeq.Accession.version )
cnvrt.ncbi <- AW.conv$RefSeq.Accession.version
names(cnvrt.ncbi) <- gsub('Scaffold','',AW.conv$corrected)
colorbrew <- read.table('~/Desktop/MAP_FIGURES/colors.brewer.conf', sep = ' ')
colorbrew <- colorbrew[grep(',',colorbrew$V3),]
colorbrew <- data.frame(circ.color=colorbrew$V1,colsplit(colorbrew$V3,',',names = c('r','g','b') ))
set.seed(666)
colorbrew <- colorbrew[sample(row.names(colorbrew),length(unique(c(male.highlights$X2,female.highlights$X2))), replace = TRUE),]
row.names(colorbrew) <- sample(unique(c(as.character(male.highlights$X2),as.character(female.highlights$X2))),replace = FALSE)
#colorbrew <- colorbrew[sample(row.names(colorbrew),length(unique(c(gff$NCBI_scaff,cnvrt.ncbi[scaffolds.f.ro$scaff],cnvrt.ncbi[scaffolds.m$scaff]))),replace = TRUE),]
#row.names(colorbrew) <- sample(unique(c(gff$NCBI_scaff,cnvrt.ncbi[scaffolds.f.ro$scaff],cnvrt.ncbi[scaffolds.m$scaff])))
pal <- rgb(colorbrew$r,colorbrew$g,colorbrew$b,maxColorValue=255)
names(pal) <- row.names(colorbrew)
##### col=pal['scaffolds'] ###############
#### Generate files to compare male and female maps ####
female.highlights <- female.highlights[!is.na(as.numeric(as.character(female.highlights$X1))),]
male.highlights <- male.highlights[!is.na(as.numeric(as.character(male.highlights$X1))),]
female.highlights$fill_color <- colorbrew[as.character(female.highlights$X2),1]
male.highlights$fill_color <- colorbrew[as.character(male.highlights$X2),1]

write.table(data.frame(paste('FH',male.highlights[,1],sep = ''),
                       male.highlights[,3:4],
                       paste('fill_color=',male.highlights[,5],sep = '')),
            file = 'm.kary',
            quote = FALSE, col.names = FALSE, row.names = FALSE)

write.table(data.frame(paste('FH',female.highlights[,1],sep = ''),
                       female.highlights[,3:4],
                       paste('fill_color=',female.highlights[,5],sep = '')     ),
          file = 'f.kary',
          quote = FALSE, col.names = FALSE, row.names = FALSE)

### Plot location of markers and number of markers per scaffold ##
## used liftover on bigfile.m generated in 1st script ###
write.table(data.frame(bigfile.m$scaff,bigfile.m$snp,bigfile.m$snp+1,bigfile.m$scaff),
            file = '~/Desktop/bigfile.m',
            quote = FALSE, sep = '\t', row.names = FALSE)
write.table(data.frame(bigfile.f$scaff,bigfile.f$snp,bigfile.f$snp+1,bigfile.f$scaff),
            file = '~/Desktop/bigfile.f',
            quote = FALSE, sep = '\t', row.names = FALSE)

### used liftover on cluster ##
male.markers <- read.table(file = 'Male.markers')
female.markers <- read.table(file = 'Fem.markers')
male.markers <- male.markers[grep('chr',male.markers$V1),]
female.markers <- female.markers[grep('chr',female.markers$V1),]
write.table(data.frame(gsub('chr','FH',male.markers$V1),
                       male.markers$V2,
                       male.markers$V2,
                       paste('color=white,stroke_color=',male.markers$V1,sep = '')),
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = '~/software/circos/current/Male.markers')

write.table(data.frame(gsub('chr','FH',female.markers$V1),
                       female.markers$V2,
                       female.markers$V2,
                       paste('color=white,stroke_color=',female.markers$V1,sep = '')),
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = '~/software/circos/current/Female.markers')

denst.m <- data.frame(scaf = unique(male.markers$V4), marks=NA)
for(i in 1:length(denst.m$marks)){denst.m$marks[i] <- length(which(male.markers$V4==as.character(denst.m$scaf[i]))) }
denst.f <- data.frame(scaf = unique(female.markers$V4), marks=NA)
for(i in 1:length(denst.f$marks)){denst.f$marks[i] <- length(which(female.markers$V4==as.character(denst.f$scaf[i]))) }
row.names(denst.m) <- denst.m$scaf
row.names(denst.f) <- denst.f$scaf

snps.m <- male.highlights[order(as.numeric(as.character(male.highlights$X1)),male.highlights$strt),]
snps.f <- female.highlights[order(as.numeric(as.character(female.highlights$X1)),female.highlights$strt),]
for(i in 1:24){
  chr.index <- which(snps.m$X1==i)
  snps.m$strt[chr.index] <- c(0,snps.m$stp[chr.index]+1)[-sum(length(chr.index),1)]
  snps.m$stp[chr.index] <- snps.m$stp[chr.index]

}
for(i in 1:24){
  chr.index <- which(snps.f$X1==i)
  snps.f$strt[chr.index] <- c(0,snps.f$stp[chr.index]+1)[-sum(length(chr.index),1)]
  snps.f$stp[chr.index] <- snps.f$stp[chr.index]

}
write.table(data.frame(FH=paste('FH',snps.m$X1,sep = ''),
                       strt=snps.m$strt,
                       stp=snps.m$stp,
                       dens=denst.m[as.character(snps.m$X2),2]),
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = 'plot.snp.m')

write.table(data.frame(FH=paste('FH',snps.f$X1,sep = ''),
                       strt=snps.f$strt,
                       stp=snps.f$stp,
                       dens=denst.f[as.character(snps.f$X2),2]),
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = '~/software/circos/current/plot.snp.f')

## CM lables for each cm ##
m.labs <-  data.frame(chr=c(1:24,1:24),
                      labs=c(format(rep.int(3000000, times = 24),scientific = FALSE),rep.int(NA,times = 24)),
                      labs.2=c(format(rep.int(3000000, times = 24),scientific = FALSE),rep.int(NA,times = 24)),
                      cm=c(format(rep.int(0,times = 24),scientific = FALSE),rep(NA,times=24)),
                      stringsAsFactors = FALSE)
for (i in 25:48){
  m.labs$labs[i] <- max(male.highlights[which(male.highlights$X1==m.labs$chr[i]),4])-3000000
  m.labs$labs.2[i] <- max(male.highlights[which(male.highlights$X1==m.labs$chr[i]),4])-3000000
  m.labs$cm[i] <- max(bigfile.m[which(bigfile.m$LG==m.labs$chr[i]),3])
}
m.labs$chr <- paste('FH',m.labs$chr,sep = '')
m.labs$cm <- round(as.numeric(m.labs$cm))
write.table(m.labs,
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = 'm.labs')

f.labs <-  data.frame(chr=c(1:24,1:24),
                      labs=c(format(rep.int(3000000, times = 24),scientific = FALSE),rep.int(NA,times = 24)),
                      labs.2=c(format(rep.int(3000000, times = 24),scientific = FALSE),rep.int(NA,times = 24)),
                      cm=c(format(rep.int(0,times = 24),scientific = FALSE),rep(NA,times=24)),
                      stringsAsFactors = FALSE)
for (i in 25:48){
  f.labs$labs[i] <- max(female.highlights[which(female.highlights$X1==f.labs$chr[i]),4])-3000000
  f.labs$labs.2[i] <- max(female.highlights[which(female.highlights$X1==f.labs$chr[i]),4])-3000000
  f.labs$cm[i] <- max(bigfile.f[which(bigfile.f$LG==f.labs$chr[i]),3])
}
f.labs$chr <- paste('FH',f.labs$chr,sep = '')
f.labs$cm <- round(as.numeric(f.labs$cm))
write.table(f.labs,
            quote = FALSE,row.names = FALSE, col.names = FALSE,
            file = 'f.labs')

#################################################
#### Sliding window analysis of recombination ####
## Generate a bedfile with scaff/snp for recomb rate
write.table(data.frame(bigfile.f$scaff,bigfile.f$snp,bigfile.f$snp,bigfile.f$cm),
            quote = F,col.names = F, row.names = F,
            file = 'Fem.BED')
write.table(data.frame(bigfile.m$scaff,bigfile.m$snp,bigfile.m$snp,bigfile.m$cm),
            quote = F,col.names = F, row.names = F,
            file = 'Mal.BED')

dir <- '~/Documents/Chapters/Other/Recombination_Rates/bedfiles/'
male <- read.table(file.path(dir,'mapped.mal.bed'), stringsAsFactors = F)
female <- read.table(file.path(dir,'mapped.fem.bed'), stringsAsFactors = F)

## used liftover (UNIX)
for (x in 1:24){
chr.m <- male[which(male$V1==paste('chr',x,sep = '')),]
chr.f <- female[which(female$V1==paste('chr',x,sep = '')),]
window <- data.frame(start=seq(0,max(c(chr.m$V2,chr.f$V2)),by = 750000),
                     stop=c(seq(0,max(c(chr.m$V2,chr.f$V2)),by = 750000)[2:length( seq(0,max(c(chr.m$V2,chr.f$V2)),by = 750000))],max(max(chr$V2))),
                     m.RcoRate=NA,
                     f.RcoRate=NA)

for (i in 1:length(window[,1])){
  ##which(as.numeric(chr$V2)>as.numeric(window$start[i])&as.numeric(chr$V2)<as.numeric(window$stop[i]))
  window$m.RcoRate[i] <- mean(dist(chr.m[which(as.numeric(chr.m$V2)>as.numeric(window$start[i])&as.numeric(chr.m$V2)<as.numeric(window$stop[i])),4])/dist(chr.m[which(as.numeric(chr.m$V2)>as.numeric(window$start[i])&as.numeric(chr.m$V2)<as.numeric(window$stop[i])),3]/1000000))
  window$f.RcoRate[i] <- mean(dist(chr.f[which(as.numeric(chr.f$V2)>as.numeric(window$start[i])&as.numeric(chr.f$V2)<as.numeric(window$stop[i])),4])/dist(chr.f[which(as.numeric(chr.f$V2)>as.numeric(window$start[i])&as.numeric(chr.f$V2)<as.numeric(window$stop[i])),3]/1000000))
}
#plot(window$start, apply(window[,3:4],1,mean))

chr.m <- data.frame(chr.m,locRec=NA)
chr.f <- data.frame(chr.f,locRec=NA)
for (i in 1:length(chr.m[,1])){
 chr.m$locRec[i] <- mean(dist(chr.m[which(chr.m$V2>chr.m$V2[i]-500000&chr.m$V2<chr.m$V2[i]+500000),4])/dist(chr.m[which(chr.m$V2>chr.m$V2[i]-500000&chr.m$V2<chr.m$V2[i]+500000),2]/1000000))
 #chr.m$locRec[i] <- mean(dist(chr.m[which(chr.m$V2>chr.m$V2[i]-500000&chr.m$V2<chr.m$V2[i]+500000),4])/(dist(chr.m[which(chr.m$V2>chr.m$V2[i]-500000&chr.m$V2<chr.m$V2[i]+500000),2]/1000000))
}

for (i in 1:length(chr.f[,1])){
  chr.f$locRec[i] <- mean(dist(chr.f[which(chr.f$V2>chr.f$V2[i]-500000&chr.f$V2<chr.f$V2[i]+500000),4])/dist(chr.f[which(chr.f$V2>chr.f$V2[i]-500000&chr.f$V2<chr.f$V2[i]+500000),2]/1000000))
}


#plot(max(c(chr.m$V2,chr.f$V2)),max(c(chr.f$locRec,chr.m$locRec),na.rm =T),cex=0)
png(paste('chr',x,'.png',sep = ''))
plot(c(0,max(c(chr.m$V2,chr.f$V2))),
     c(0,200),
     cex=0, ylab = 'cM/MB', xlab = paste('Chromosome',x,'position'),
     main = 'F. heteroclitus sex specific recomb rate')
points(chr.m$V2,chr.m$locRec, cex=1, col='blue', pch=20)
points(chr.f$V2,chr.f$locRec, cex=1, col='red', pch=20)
dev.off()
}

####################################################

# Need data.frame(marker,chrom, mb.position)
female.map <- data.frame(chr=gsub('chr','',female$V1),cm.pos=female$V4,mb.pos=female$V3/1000000)
female.map <- female.map[order(female.map$chr,female.map$mb.pos),]

male.map <- data.frame(chr=gsub('chr','',male$V1),cm.pos=male$V4,mb.pos=male$V3/1000000)
male.map <- male.map[order(male.map$chr,male.map$mb.pos),]
## need to remove markers that are not linear along map ('xoi')

#Set the window size for calculating recombination rate
window <- 5

est.JM <- function(X,Z=male.map,win=window){
  index <- which(Z$chr==X)
  return(est.recrate.jm(Z$cm.pos[index],Z$mb.pos[index],win))
}


m.rate <- est.JM(1)

index <- which(male.map$chr==1

cor(male.map$cm.pos[index],male.map$mb.pos[index])

snp <- Z$cm.pos[i]

 if (snp < Z$cm.pos[i-1] & snp < Z$cm.pos[i-1]){

 }

 est.recrate.jm <- function (genmap, phymap, pos = NULL, window = 5)
 {
   rate <- .C("R_est_recrate", as.integer(length(genmap)), as.double(genmap),
       as.double(phymap), as.integer(length(pos)), as.double(pos),
       rate = as.double(rep(0, length(pos))), as.double(window),
       as.double(rep(0, length(genmap) - 1)), PACKAGE = "xoi")$rate
   data.frame(pos = pos, rate = rate)
}

 ### Attemtping to get recombination rate for maps
 
